↓ Skip to main content
  1. Posts/

poj 3368 Frequent values (暴力+rmq,分类讨论)

·786 words·2 mins
Note: This article is available in Chinese only. 本文暂无英文版本。 View original

poj 3368 题目链接

题意:给出n个非减的数a[i],求区间[l,r]中出现次数最多的数的出现的次数。

思路:由于数列非减,那么相等的数一定相邻。很容易系哪个到构造另一个数组f[i],表示从当前位置向左边延伸最多延伸几个相等的数。

f[i] = f[i-1] + 1 (iff a[i]==a[i-1])

然后查询的时候。

如果直接用ST算法查询rmq的话。。。

可能产生错误结果,原因是f[i]是从左边1到i这段连续区间里当前数出现的次数。

但是查询区间不一定是从1开始,所以查询区间内的第一段连续相等的数可能不完整。。。想了半天。。最后看了题解,发现是这部分暴力来搞。但是如果所有数列中所有数都相等,这样的复杂度就达到了o(1E10)?。。。2s应该过不了吧。。。但是所有题解都是这么写的。。。不是很懂。。。所谓的面向数据编程?

不过还是有启示的:分类讨论的思想。一道题未必用一种算法解。如果因为一小部分导致某算法不能用的话,不妨暴力搞之然后再用这个算法。

代码实现
  1/* ***********************************************
  2Author :111qqz
  3Created Time :2016年05月18日 星期三 13时44分47秒
  4File Name :code/poj/3368.cpp
  5************************************************ */
  6
  7#include <cstdio>
  8#include <cstring>
  9#include <iostream>
 10#include <algorithm>
 11#include <vector>
 12#include <queue>
 13#include <set>
 14#include <map>
 15#include <string>
 16#include <cmath>
 17#include <cstdlib>
 18#include <ctime>
 19#define fst first
 20#define sec second
 21#define lson l,m,rt<<1
 22#define rson m+1,r,rt<<1|1
 23#define ms(a,x) memset(a,x,sizeof(a))
 24typedef long long LL;
 25#define pi pair < int ,int >
 26#define MP make_pair
 27
 28using namespace std;
 29const double eps = 1E-8;
 30const int dx4[4]={1,0,0,-1};
 31const int dy4[4]={0,-1,1,0};
 32const int inf = 0x3f3f3f3f;
 33const int N=1E5+7;
 34int n;
 35pi a[N];
 36int q;
 37int dp[N][20];
 38
 39void init_rmq()
 40{
 41    for ( int i =  1 ;i  <= n ; i++) dp[i][0] = a[i].sec;
 42
 43    for ( int j = 1  ; (1<<j)<= n ; j++)
 44	for ( int i = 1 ; i + (1<<j)-1 <= n ; i++)
 45	    dp[i][j] = max(dp[i][j-1],dp[i+(1<<(j-1))][j-1]);
 46}
 47
 48int rmq_max(int l,int r)
 49{
 50    if (l>r) return 0; //因为l+1可能大于b
 51    int k = 0  ;
 52    while (1<<(k+1)<=(r-l+1)) k++;
 53    return max(dp[l][k],dp[r-(1<<k)+1][k]);
 54
 55}
 56int main()
 57{
 58	#ifndef  ONLINE_JUDGE
 59	freopen("code/in.txt","r",stdin);
 60  #endif
 61
 62	while (scanf("%d",&n)!=EOF)
 63	{
 64	    ms(dp,0);
 65	    ms(a,0);
 66
 67	    if (n==0) break;
 68	    scanf("%d",&q);
 69	    for ( int i = 1 ; i <= n ; i++)
 70	    {
 71		int x;
 72		scanf("%d",&x);
 73		a[i]=make_pair(x,1);
 74	    }
 75	    a[n+1].fst = inf;
 76
 77	    for ( int i = 2 ; i <= n ; i++)
 78	    {
 79		if (a[i].fst==a[i-1].fst)
 80		{
 81		    a[i].sec = a[i-1].sec+1;
 82		}
 83	    }
 84
 85//	    for ( int i = 1 ;i  <= n ; i++) cout<<a[i].fst<<" "<<a[i].sec<<endl;
 86
 87	    init_rmq();
 88	    while (q--)
 89	    {
 90		int l,r;
 91		scanf("%d %d",&l,&r);
 92		int tmp = l;
 93		while (tmp<r&&a[tmp].fst==a[tmp+1].fst) tmp++; //mdzz,最坏复杂度1E10啊。。。题解都是面向数据编程吗
 94		int ans = rmq_max(tmp+1,r);
 95//		cout<<"tmp-l:"<<tmp-l+1<<endl;
 96		ans = max(ans,tmp+1-l);
 97		printf("%d\n",ans);
 98	    }
 99
100	}
101
102  #ifndef ONLINE_JUDGE
103  fclose(stdin);
104  #endif
105    return 0;
106}

Related

lightoj 1081 Square Queries (二维rmq,降维)

·434 words·1 min
lightoj 1081 题目链接 题意:和上一道一样,但是由于size变成了500,如果按照之前的做法会tle + mle… 很容易发现,由于是方阵,长宽是相等的,所以有一维是可以省略的。 也就是所谓的降维?

poj 2019 Cornfields (二维rmq)

·497 words·1 min
poj2019题目链接 题意:给一个方阵,k个查询,每个查询求某个方阵的最大值和最小值之差。 思路:二维rmq.同时用到最大值和最小值的话可以把初始化写在一起。 代码实现 1/* *********************************************** 2Author :111qqz 3Created Time :2016年05月16日 星期一 18时31分23秒 4File Name :code/poj/2019.cpp 5************************************************ */ 6 7#include <cstdio> 8#include <cstring> 9#include <iostream> 10#include <algorithm> 11#include <vector> 12#include <queue> 13#include <set> 14#include <map> 15#include <string> 16#include <cmath> 17#include <cstdlib> 18#include <ctime> 19#define fst first 20#define sec second 21#define lson l,m,rt<<1 22#define rson m+1,r,rt<<1|1 23#define ms(a,x) memset(a,x,sizeof(a)) 24typedef long long LL; 25#define pi pair < int ,int > 26#define MP make_pair 27 28using namespace std; 29const double eps = 1E-8; 30const int dx4[4]={1,0,0,-1}; 31const int dy4[4]={0,-1,1,0}; 32const int inf = 0x3f3f3f3f; 33const int N=251; 34int a[N][N]; 35int dp[N][N][8][8]; 36int dp2[N][N][8][8]; 37int n,b,q; 38 39void init_rmq() 40{ 41 for ( int i = 1 ;i <= n ; i++) 42 for ( int j = 1 ; j <= n ; j++) 43 dp[i][j][0][0] = dp2[i][j][0][0] = a[i][j]; 44 45 46 for ( int i = 0 ; (1<<i)<= n ; i++) 47 for ( int j = 0 ; (1<<j) <= n ; j++) 48 if (i==0 && j==0) continue; 49 else for ( int p = 1 ; p + (1<<i)-1 <= n ; p++) 50 for ( int q = 1 ; q + (1<<j)-1 <= n ; q++) 51 if (i==0) 52 { 53 dp[p][q][i][j] = max(dp[p][q][i][j-1],dp[p][q+(1<<(j-1))][i][j-1]); 54 dp2[p][q][i][j] = min(dp2[p][q][i][j-1],dp2[p][q+(1<<(j-1))][i][j-1]); 55 } 56 else 57 { 58 dp[p][q][i][j] = max(dp[p][q][i-1][j],dp[p+(1<<(i-1))][q][i-1][j]); 59 dp2[p][q][i][j] = min(dp2[p][q][i-1][j],dp2[p+(1<<(i-1))][q][i-1][j]); 60 } 61} 62 63 64int _rmq(int x1,int y1,int x2,int y2) 65{ 66 int k1 = 0 ; 67 int k2 = 0 ; 68 while (1<<(k1+1)<=x2-x1+1) k1++; 69 while (1<<(k2+1)<=y2-y1+1) k2++; 70 71 int tmp1 = dp[x1][y1][k1][k2]; 72 int tmp2 = dp[x2-(1<<k1)+1][y1][k1][k2]; 73 int tmp3 = dp[x1][y2-(1<<k2)+1][k1][k2]; 74 int tmp4 = dp[x2-(1<<k1)+1][y2-(1<<k2)+1][k1][k2]; 75 76 int mx = max(max(tmp1,tmp2),max(tmp3,tmp4)); 77 78 tmp1 = dp2[x1][y1][k1][k2]; 79 tmp2 = dp2[x2-(1<<k1)+1][y1][k1][k2]; 80 tmp3 = dp2[x1][y2-(1<<k2)+1][k1][k2]; 81 tmp4 = dp2[x2-(1<<k1)+1][y2-(1<<k2)+1][k1][k2]; 82 83 int mn = min(min(tmp1,tmp2),min(tmp3,tmp4)); 84 85 // cout<<"mx:"<<mx<<" mn:"<<mn<<endl; 86 87 return mx - mn; 88} 89 90 91int main() 92{ 93 #ifndef ONLINE_JUDGE 94 freopen("code/in.txt","r",stdin); 95 #endif 96 scanf("%d %d %d",&n,&b,&q); 97 for ( int i = 1 ; i <= n ; i++) 98 for ( int j = 1 ; j <= n ; j++) scanf("%d",&a[i][j]); 99 init_rmq(); 100 101 while (q--) 102 { 103 int x1,y1; 104 scanf("%d %d",&x1,&y1); 105 printf("%d\n",_rmq(x1,y1,x1+b-1,y1+b-1)); 106 } 107 108 109 110 #ifndef ONLINE_JUDGE 111 fclose(stdin); 112 #endif 113 return 0; 114}

hdu 2888 check corners (二维rmq模板题)

·484 words·1 min
hdu2888题目链接 题意:问某个矩阵内的最大值,并且问最大值是否是在四个角中出现。 思路:二维rmq.需要注意数组稍微开大1就会MLE,因为是四维数组,一维大一点,整个就会大很多==。

hdu 3183 A Magic Lamp ( 暴力)

·455 words·1 min
hdu3183题目链接 题意:n位长的数字串(n<=1000),删掉m个(m<=n),使得剩下的数字串表示的数字最小。 忽略前导0. 思路:暴力搞就可以。要注意每位数字是有一定位置的范围的。比如当前是第i位数字,后面还要取n-m-i位数字,那么第i位数字最多只能取到第k位,k=m+i,因为这样才能保证后面还有n-m-i位数字。